// Coordinates.java
//Written by: Maria Kazandjieva, marykaz@hotmail.com, Summer 2005

// Displays information about node location
// created 06/14/05


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.Rectangle.*;
import java.lang.*;
import java.text.*;
import javax.swing.border.*;
import java.util.Random;



public class Coordinates extends JFrame  implements ActionListener
{
	// declare and initialize variables

	private int numberNodes = Global.numberNodes;
	private Node[] nodes_array = Global.nodes_array;
	Node myNode;

	int[] x = new int[numberNodes];
	int[] y = new int[numberNodes];

	final int MAX = 100;
	Container c;
	JPanel dataPanel, xyPanel;
	JScrollPane xyPane;
	CustomPanel displayPanel;
	JFormattedTextField widthTA, heightTA;
	JLabel widthL, heightL, label1;
	JLabel[] xyL = new JLabel[numberNodes];
	JButton goB;
	int w_unit, w;
	int h_unit, h;
	Border raisedetched = BorderFactory.createEtchedBorder(EtchedBorder.RAISED);


	public Coordinates() {

	super("Location of nodes");
	this.setLocation(325, 200);
	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

	c = getContentPane();
	dataPanel = new JPanel (new BorderLayout());
	dataPanel.setBorder(raisedetched);

	xyPanel = new JPanel (new GridLayout(numberNodes,1));
	xyPanel.setBorder (raisedetched);

	for (int j=0; j<numberNodes; j++) {
		myNode = nodes_array[j];
		xyL[j] = new JLabel("Node " +(j+1)+ " at ("+ myNode.getX() + "," + myNode.getY() + ")" );
		xyPanel.add(xyL[j]);
	}

	xyPane = new JScrollPane(xyPanel);
	xyPane.setPreferredSize(new Dimension(130,420));

	c.add(xyPane, BorderLayout.EAST);

	//set up text areas where the user can enter information about the nodes network area
	// they areinitialized to 100 and formatted so that only digit input is accepted

	widthTA = new JFormattedTextField(new java.text.DecimalFormat("#####0"));
	widthTA.setColumns(5);
	widthTA.setText("100");
	heightTA = new JFormattedTextField(new java.text.DecimalFormat("#####0"));
	heightTA.setColumns(5);
	heightTA.setText("100");

	widthL = new JLabel ("Width: ");
	heightL = new JLabel ("Height: ");

	label1 = new JLabel ("Enter the dimensions of the network area.");

	dataPanel = new JPanel();

	dataPanel.add(widthL);
	dataPanel.add(widthTA);
	dataPanel.add(heightL);
	dataPanel.add(heightTA);

	goB = new JButton ("Display nodes");
	goB.addActionListener(this);
	dataPanel.add(goB);

	c.add(dataPanel, BorderLayout.NORTH);

	//we create an object of type CustomPanel which will contain the graph with plotted nodes
	displayPanel = new CustomPanel();
	displayPanel.setBorder(raisedetched);
	c.add(displayPanel, BorderLayout.CENTER);

	//create an appropriate menu
	JMenuBar menu = new JMenuBar();
	setJMenuBar (menu);
	JMenu fileMenu = new JMenu("File");

	JMenuItem home = new JMenuItem("Selection screen");
	home.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		new ChoiceScreen();
		setVisible(false);
	}
	}
	);
	fileMenu.add(home);

	JMenuItem exit = new JMenuItem ("Exit");

	exit.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		System.exit(0);
	}
	}
	);
	fileMenu.add(exit);

	menu.add(fileMenu);

	JMenu helpMenu = new JMenu ("Help");
	menu.add(helpMenu);
	JMenuItem about = new JMenuItem ("About...");
	about.addActionListener ( new ActionListener() {
		public void actionPerformed(ActionEvent e)
	{
	JOptionPane.showMessageDialog(Coordinates.this, "This application was created by Maria Kazandjieva", "About", JOptionPane.INFORMATION_MESSAGE);
	}
	}
	);

	helpMenu.add(about);

	//set up frame preferences and pack and show the frame
	setSize (560,510);
	setResizable(false);
	show();
}

//this method gets the width and heiht of the area, scales down things so they fit into a 400x400
// area and calls the method that draws te graph

public void actionPerformed (ActionEvent e) {

	w = Integer.parseInt(widthTA.getText());
	h = Integer.parseInt(heightTA.getText());

	// the purpose of the variables w_unit and h_unit is scaling.
	/* in order to have all nodes fit into the 400x400 area, no matter how big the actual 	network is. Using the values that the user has entered we can scale down the network view
	while still preserving its topology */


	w_unit = 400/w;
	h_unit = 400/h;

	if (e.getSource() == goB) {
		for (int i=0; i<numberNodes; i++) {
			myNode = nodes_array[i];
			x[i] = myNode.getX();
			y[i] = myNode.getY();
		}
			displayPanel.draw(w_unit, h_unit, x, y, numberNodes);


	}
}

}