//CustomPanel.java
//Written by: Maria Kazandjieva, marykaz@hotmail.com, Summer 2005

//This java class is used to override the paintComponent method in JPanel.
//In this way we can combine customized graphics with Swing components.



import java.awt.*;
import javax.swing.*;



public class CustomPanel extends JPanel {

	// declare and initialize variables

	private int w_unit, h_unit;
	private int x_value, y_value;
	private int numberNodes;
	private int[] x = new int[numberNodes];
	private int[] y = new int[numberNodes];

	public void paintComponent (Graphics g)
	{
		super.paintComponent(g);	//required so the mathod can be overridden


	for (int i=0; i < numberNodes; i++){

	x_value = x[i];
	y_value = y[i];

	//the following two statements create a red dot that represents the location of the node
	// to get the coordinates of the graphics we use the x and y coordinate values passed in
	// and multiply them by unit values which are used for correct scaling
	g.setColor (Color.red);
	g.fillRect((w_unit * x_value), (h_unit * y_value), 5, 5);

	//a sting writes outthe number of the node
	g.setColor(Color.black);
	g.drawString(""+(i+1),(w_unit * x_value+ 10),  (h_unit * y_value));
	}
	}

	public void draw (int w_unit, int h_unit, int[] x, int[] y, int numberNodes)
	{

	this.w_unit = w_unit;
	this.h_unit = h_unit;
	this.x=x;
	this.y=y;
	this.numberNodes = numberNodes;

	repaint();
	}
}