// Energy.java
//Written by: Maria Kazandjieva, marykaz@hotmail.com, Summer 2005

// Displays information about the energy remaining in each node
// created 06/10/05
//package bluetooth_project;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.Rectangle.*;
import java.lang.*;
import java.util.*;



public class Energy extends JFrame
{
	// declare and initialize variables

	Node myNode;
	Node[] nodes_array = Global.nodes_array;
	int numberNodes = Global.numberNodes;

	private final int MAX = 100;

	private double[] energy = new double[numberNodes];; // contains the energy lever numbers
	private JCheckBox[] nodes;
	private JLabel[] visualL, energyL;
	private Container c;
	private JPanel infoPanel;
	private JScrollPane scrollPane;
	private Border raisedetched = BorderFactory.createEtchedBorder(EtchedBorder.RAISED);
	private boolean[] toggle = new boolean[numberNodes];
	private Icon[] bar;
	private JMenuBar menu;
	private String color = "RED";

	public Energy() {

	super ("Energy information about the nodes");
	this.setLocation(325, 200);			// set location forthe window on the desktop

	c = getContentPane();
	c.setLayout (new FlowLayout());		// get a content pane; set it's layout

	this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

	infoPanel = new JPanel();		// create a panel to hold all the information
	infoPanel.setBorder(raisedetched);
	infoPanel.setLayout (new GridLayout (numberNodes, 3));	//set its layout

	// initialize arrays
	nodes = new JCheckBox[numberNodes];
	energyL = new JLabel [numberNodes];
	bar = new Icon[numberNodes];
	visualL = new JLabel [numberNodes];

	CheckBoxHandler handler = new CheckBoxHandler();

	// this part of the code uses a random number generatior to get values for the energy level
	// in actuallity, those values will be sent via bluetooth into the application
	// this is temporary, meant to help with the simulation
	// the loop is also used to initialize the boolean array

	Random rand = new Random();

	for (int j=0; j<numberNodes; j++){
		//energy[j] = rand.nextInt(MAX);
		toggle[j] = true;
	}


	//this loop creates the various JComponents and adds them the the JPanel
	// it also adds a listener so we can control whether information about a node is displayed

	for (int i=0; i<numberNodes; i++) {
		myNode = nodes_array[i];

		nodes[i] = new JCheckBox ("Node " + (i+1), toggle[i]);
		infoPanel.add (nodes[i]);
		nodes[i].addItemListener(handler);

		bar[i] = new Bar((int)Math.ceil (myNode.getEnergy()), 15, 255, 0,0);

		visualL[i] = new JLabel ("");
		visualL[i].setIcon(bar[i]);
		visualL[i].setToolTipText("energy left: " + myNode.getEnergy());

		infoPanel.add(visualL[i]);

		energyL[i] = new JLabel ("Energy: " + myNode.getEnergy());

		infoPanel.add(energyL[i]);

	}

	// create a JScrollPane which will aide in reasonable space usage
	scrollPane = new JScrollPane(infoPanel);
	scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
      scrollPane.setPreferredSize(new Dimension(410,360));

	c.add(scrollPane);

	//Create a menu bar that contains severc options: exit, return to the main screen, etc.
	JMenuBar menu = new JMenuBar();
	setJMenuBar (menu);
	JMenu fileMenu = new JMenu("File");

	JMenuItem home = new JMenuItem("Selection screen");
	home.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		new ChoiceScreen();
		setVisible(false);
	}
	}
	);
	fileMenu.add(home);

	JMenuItem exit = new JMenuItem ("Exit");

	exit.addActionListener (new ActionListener() {
	public void actionPerformed (ActionEvent e)
	{
		System.exit(0);
	}
	}
	);
	fileMenu.add(exit);


	menu.add(fileMenu);
	JMenu optionsMenu = new JMenu ("Options");
	menu.add (optionsMenu);
	JMenuItem select = new JMenuItem ("Select all");
	optionsMenu.add(select);
	select.addActionListener (new ActionListener() {
		public void actionPerformed(ActionEvent e)
	{
		for (int i=0; i<numberNodes; i++)
		{
			energyL[i].setVisible(true);
			visualL[i].setVisible(true);
			nodes[i].setSelected(true);
		}
	}
	}
	);

	JMenu helpMenu = new JMenu ("Help");
	menu.add(helpMenu);
	JMenuItem about = new JMenuItem ("About...");
	about.addActionListener ( new ActionListener() {
		public void actionPerformed(ActionEvent e)
	{
	JOptionPane.showMessageDialog(Energy.this, "This application was created by Maria Kazandjieva", "About", JOptionPane.INFORMATION_MESSAGE);
	}
	}
	);

	helpMenu.add(about);

	//set preferences for the frame
	setSize (425,425);
	setResizable(false);

	// pack the frame and display it
	show();

	}


// a class that handles the check boxes
// by checking or unchecking a box, the appropriate node information dis- or reappears
private class CheckBoxHandler implements ItemListener {

public void itemStateChanged (ItemEvent e)
{
	for (int i=0; i<numberNodes; i++)
	{
		if (e.getSource() == nodes[i])
		{
			energyL[i].setVisible(!toggle[i]);
			visualL[i].setVisible(!toggle[i]);
			toggle[i] = !toggle[i];
		}
	}
	c.validate(); //repaint the components on the frame
}
}

}


