// readResponse.java
// Modified by: Maria Kazandjieva, marykaz@hotmail.com. Summer 2005

/* The readResponse class reads the response that is sent back from the reader after a request is sent */

import javax.comm.*;
import java.util.*;
import java.io.*;
public class readResponse {

	//readResponse reads the response comming in from the RFID reader and returns a stringbuffer version of the response
	public StringBuffer readResponse(SerialPort myPort, CommPort thePort) throws IOException, NoSuchPortException, PortInUseException,
				UnsupportedCommOperationException {
		DataInputStream inStream;
		try {
			inStream = new DataInputStream(thePort.getInputStream());
		}
		catch (IOException e) {
			System.err.println("Can't open input Stream");
			inStream = null;
		}
		//read all the lines of the response into a byte array
		int input =0;
		byte [] byteArray = new byte[16];
		// Read low order byte
		if ((input = inStream.read()) == -1)
			throw new IOException();
		byteArray[0] = (byte)input;
		for (int y=1; inStream.available() > 0; y++) {
		   	if( (input = inStream.read()) == -1)
		       	throw new IOException();
			byteArray[y] = (byte)input;
		}
	    //must split up the array into two smaller arrays of size 8
	    //this is for printing purposes since "long" can only handle 64 bits
	    //the code below transfers the first 8 bytes of the array into the first
	    //of the two sub arrays
	    byte[] newByteArray1 = new byte[8];
		newByteArray1[0] = byteArray[0];
		newByteArray1[1] = byteArray[1];
		newByteArray1[2] = byteArray[2];
		newByteArray1[3] = byteArray[3];
		newByteArray1[4] = byteArray[4];
		newByteArray1[5] = byteArray[5];
		newByteArray1[6] = byteArray[6];
		newByteArray1[7] = byteArray[7];

		//read the data into a ByteArrayInputStream and a DataInputStream to display the data
		ByteArrayInputStream byteIn1 = new ByteArrayInputStream(newByteArray1);
		DataInputStream dataIn1 = new DataInputStream(byteIn1);
		long lng = dataIn1.readLong();
		//convert the long value into a hex string
		String hexString = Long.toHexString(lng);

		//the code below reads the next 8 bytes of the byte array into the second sub array
		byte[] newByteArray = new byte[8];
		newByteArray[0] = byteArray[8];
		newByteArray[1] = byteArray[9];
		newByteArray[2] = byteArray[10];
		newByteArray[3] = byteArray[11];
		newByteArray[4] = byteArray[12];
		newByteArray[5] = byteArray[13];
		newByteArray[6] = byteArray[14];
		newByteArray[7] = byteArray[15];

		ByteArrayInputStream newByteIn = new ByteArrayInputStream(newByteArray);
		DataInputStream newDataIn = new DataInputStream(newByteIn);
		long lng1 = newDataIn.readLong();
		String hexString1 = Long.toHexString(lng1);

		//append all the bytes of the response together to form one response
		StringBuffer stringBuff = new StringBuffer(hexString);
		stringBuff.append(hexString1);
		inStream.close();
		return stringBuff;
	}
}