/*

Author: Kevin Walsh, 2004
Modified by: Maria Kazandjieva, 2005, marykaz@hotmail.com

this class handles the responses sent from the reader. It parses the stringbuffer
into the different response fields.

*/

import java.util.*;

public class responseHandler {

	//constructor for the responseHandler class
	public responseHandler() {}

	//this method returns the message length value contained in the response
	public String getMessageLength(StringBuffer value) {
		String mesLength = value.substring(1,3);
		return mesLength;
	}
	//this method returns the response code value contained in the response
	public String getResponseCode(StringBuffer value) {
		String respCode = value.substring(3,5);
		return respCode;
	}

	// this method returns the data read from a tag
	public String getTagData (StringBuffer value) {
		String tagData = value.substring(5,13);
		return tagData;
	}

	//this method returns the CRC value contained in the response
	public String getCRC(StringBuffer value, String respCode) {
		if (respCode.equals("94")) {
			String crc = value.substring(9,13);
			return crc;
		}
		else if(respCode.equals("14")) {
			String crc = value.substring(25,29);
			return crc;
		}
		return "error";
	}
	//this method returns the tag ID value contained in the response
	public String getTagID(StringBuffer value) {
		String tagID = value.substring(5,21);
		return tagID;
	}
}